window.addEventListener('load', function() {
  document.body.addEventListener('touchmove', function(e) {
    e.preventDefault();
  }, false);
}, false);

$(document).ready(function(){
  var storage = window.localStorage;
  FastClick.attach(document.body);

  if( /Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent) ) {
    $(document).bind("deviceready", initApp);
    $(document).bind("resume", initApp);
  } else {
    initApp();
  }

  //navigator.geolocation.getCurrentPosition(successFunction, errorFunction);
  //var geocoder = new google.maps.Geocoder();
  //var city;
  var bgColor;
  var shareMsg;
  var shareUrl;
  var lat;
  var lng;
  var renew = false;

  function initApp() {
    if (navigator.geolocation) {
      $( "#reload" ).addClass("rotate");
      $( "span.city" ).text("Searching...");
      $( "span.message" ).text("I'm looking for you...");
      navigator.geolocation.getCurrentPosition(successFunction, errorFunction, { enableHighAccuracy: true });
    }
    if( /Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent) ) {
      var admobid = (/(ipod|iphone|ipad)/i.test(navigator.userAgent)) ? 'ca-app-pub-5698349429157405/3751725576' : 'ca-app-pub-5698349429157405/3472523971' ;
      AdMob.createBanner({
        adId:admobid,
        position:AdMob.AD_POSITION.BOTTOM_CENTER,
        bgColor:'white',
        autoShow: true
      });
    }
    var gender = storage.getItem("gender");
    var unit = storage.getItem("unit");
    var clipart = JSON.parse(storage.getItem("clipart"));
    if(gender) $("#"+gender).prop("checked", true);
    if(unit) $("#"+unit).prop("checked", true);
    $('#clipart').empty();
    if(clipart) {
      $.each(clipart, function(k, v) {
        $('#clipart').append($('<img>',{class:'clipart',src:'images/clipart/'+ v +'.svg'}))
      });
    } else {
      $.each(["Base", "Trousers", "Shoes", "Tshirt", "Hair"], function(k, v) {
        $('#clipart').append($('<img>',{class:'clipart',src:'images/clipart/'+ v +'.svg'}))
      });
    }
  }

  //Get the latitude and the longitude;
  function successFunction(position) {
    lat = position.coords.latitude;
    lng = position.coords.longitude;
    updateWeather(lat, lng);
  }

  function errorFunction(error){
    console.log('code: ' + error.code + '\n message: ' + error.message + '\n');
    $( "span.message" ).text("Location is needed for the app to work. Please allow access to Location data.");
  }

  $("#reload").on("touchstart click", function(e) {
    e.stopPropagation(); e.preventDefault();
    console.log("RELOAD", lat, lng);
    if(lat && lng) {
      updateWeather(lat, lng);
    } else {
      $("#reload").addClass("rotate");
      navigator.geolocation.getCurrentPosition(successFunction, errorFunction, { enableHighAccuracy: true });
    }
  });

  $("#openShare").on("touchstart click", function(e) {
    e.stopPropagation(); e.preventDefault();
    console.log("SHARE", lat, lng);
    /*
    html2canvas($(".containerdiv"), {
      letterRendering: true,
      background: bgColor,
      onrendered: function(canvas) {
        var imgDataUrl = canvas.toDataURL();
      }
    });*/
    if(shareMsg && shareUrl) {
      var options = {
        message: shareMsg,
        subject: 'What to Wear',
        //files: [imgDataUrl],
        url: shareUrl,
        chooserTitle: 'Pick an app'
      }

      var onSuccess = function(result) {
        console.log("Share completed? " + result.completed); // On Android apps mostly return false even while it's true
        console.log("Shared to app: " + result.app); // On Android result.app is currently empty. On iOS it's empty when sharing is cancelled (result.completed=false)
      }

      var onError = function(msg) {
        console.log("Sharing failed with message: " + msg);
      }
      window.plugins.socialsharing.shareWithOptions(options, onSuccess, onError);
    } else {
      $( "span.message" ).text("There is no weather data to share!");
    }
  });

  $("#openSettings").leanModal(undefined, onClose);
  function onClose(){
    console.log("CLOSE SETTINGS", lat, lng);
    if(renew) {
      renew = false;
      if(lat && lng) {
        updateWeather(lat, lng);
      } else {
        $("#reload").addClass("rotate");
        navigator.geolocation.getCurrentPosition(successFunction, errorFunction, { enableHighAccuracy: true });
      }
    }
  }

  $('#settings-ct input').on('change', function() {
    storage.setItem("gender", $('input[name=gender]:checked', '#settings-ct ').val());
    storage.setItem("unit", $('input[name=unit]:checked', '#settings-ct ').val());
    renew = true;
  });
  /*
  function getCity(lat, lng) {
    var latlng = {lat: parseFloat(lat), lng: parseFloat(lng)};
    geocoder.geocode({'location': latlng}, function(results, status) {
      if (status == google.maps.GeocoderStatus.OK) {
        if (results[1]) {
          for (var i=0; i<results[0].address_components.length; i++) {
            if(results[0].address_components[i].types.toString() == ["locality", "political"].toString()){
              city = results[0].address_components[i].long_name;
              $( "span.city" ).text(city);
              updateWeather(city, lat, lng);
              return true;
            }/* else if (results[0].address_components[i].types.toString() == ["country", "political"].toString()) {
              country = results[0].address_components[i].long_name;
            } else if (results[0].address_components[i].types.toString() == ["administrative_area_level_1", "political" ].toString()) {
              state = results[0].address_components[i].short_name;
            }* /
          }
        } else {
          console.log("No results found");
        }
      } else {
        console.log("Geocoder failed due to: " + status);
      }
      updateWeather("Unknown", lat, lng);
      return false;
    });
  }
  */
  function updateWeather(lat, lng) {
    $("#reload").addClass("rotate");
    var gender = storage.getItem("gender");
    var unit = storage.getItem("unit");
    console.log("Settings", gender, unit);
    $.getJSON( "https://www.diecke.nl/wtw/wtw.php?callback=?",
    { gender: gender, unit: unit, lat : encodeURIComponent(lat), lng : encodeURIComponent(lng) },
    function( data ) {
      bgColor = data.color[0];
      shareMsg = data.shareMsg;
      shareUrl = data.shareUrl;
      if(unit != data.units) {
        storage.setItem("unit", data.units);
        $("#"+data.units).prop("checked", true);
      }
      storage.setItem("clipart", JSON.stringify(data.clipart));
      console.log(data);
      $( "span.city" ).text(data.city);
      $( "span.current" ).html(data.current + "&deg;");
      $( "span.message" ).text(data.message);
      $( "#current" ).html(data.current + "&deg;");
      $( "#currentIcon" ).attr("src", "images/icons/weather/" + data.currentIcon + ".svg");
      $( "#todayHigh" ).html(data.todayHigh + "&deg;");
      $( "#todayLow" ).html(data.todayLow + "&deg;");
      $( "#todayIcon" ).attr("src", "images/icons/weather/" + data.todayIcon + ".svg");
      $( "#tomorrowHigh" ).html(data.tomorrowHigh + "&deg;");
      $( "#tomorrowLow" ).html(data.tomorrowLow + "&deg;");
      $( "#tomorrowIcon" ).attr("src", "images/icons/weather/" + data.tomorrowIcon + ".svg");
      $('.bg.hidden').css({
        background: "-webkit-linear-gradient(141deg, " + data.color[0] + " 0%, " + data.color[1] + " 51%, " + data.color[2] + " 75%)",
        background: "linear-gradient(141deg, " + data.color[0] + " 0%, " + data.color[1] + " 51%, " + data.color[2] + " 75%)"
      });
      $('.bg').toggleClass('hidden');
      $('#clipart').empty();
      $.each(data.clipart, function(k, v) {
        $('#clipart').append($('<img>',{class:'clipart',src:'images/clipart/'+ v +'.svg'}))
      });
      $('#info').empty();
      $.each(data.info, function(k, v) {
        $('#info').append('<p><span>'+ v[0] +'</span><img src="images/icons/'+ v[1] +'.svg" /></p>')
      });
      $('.switch-selection').css({
        "background-image": "-webkit-linear-gradient(top, " + data.color[0] + ", " + data.color[1] + ")",
        "background-image": "linear-gradient(to bottom, " + data.color[0] + ", " + data.color[1] + ")"
      });
      $("#reload").removeClass("rotate");
    }).fail(function() {
      console.log( "error" );
      $( "span.message" ).text("Error while collecting weather info, are you connected to internet?");
    });
  }
});
